package example_select_sort_integers;

import java.util.Arrays;

public class SelectSortModular {

	public static void main(String[] args) {
		int[][] vals1 = { {9,8,7,6,5,4,3,2,1}, {5,3,1,2,9,7,6,4,8}, {3, 1} };
//		int[][] vals1 = { {4,3,5,7} };		
		int[][] vals2={ {9,8,7,6,5,4,3,2,1}, {5,3,1,2,9,7,6,4,8}, {3, 1} };
		int[][] vals3={ {9,8,7,6,5,4,3,2,1}, {5,3,1,2,9,7,6,4,8}, {3, 1} };
		int[][] vals4={ {9,8,7,6,5,4,3,2,1}, {5,3,1,2,9,7,6,4,8}, {3, 1} };

		for( int i=0; i<vals1.length; i++) {

			System.out.print( "Original: " + Arrays.toString( vals1[i] ) );
			selectSort(vals1[i]);
			System.out.println( ", Sorted: " + Arrays.toString( vals1[i] ) );
		}
	}
	
	public static void selectSort(int[] vals) {
		selectSort(vals,vals.length-1);
		
	}
	
	private static void selectSort(int[] vals, int end) {
		if(end == 0) return;
		
		int indx = findIndexOfMax(vals,end);
		swap(vals,indx,end);
		selectSort(vals,end-1);
	}
	
	private static int findIndexOfMax(int[] vals, int end) {
		int max = vals[0];
		int indx = 0;
		for(int i=1; i<=end; i++) {
			if(vals[i]>max) {
				max = vals[i];
				indx = i;
			}
		}
		return indx;
	}
	
	private static void swap(int[] vals, int i, int j) {
		int temp = vals[i];
		vals[i] = vals[j];
		vals[j] = temp;
	}

	// Can do swap without a temp with this math trick, but only works
	// if locations are different, i.e. i<>j
	private static void swap2(int[] vals, int i, int j) {
//		System.out.println(Arrays.toString(vals) + ", " + i + ", " + j);
		if(i==j)return;
		vals[i] = vals[i] + vals[j];
		vals[j] = vals[i] - vals[j];
		vals[i] = vals[i] - vals[j];
//		System.out.println(Arrays.toString(vals));
	}

}
