package examples_helper_primitive;

public class CountCodeAbc {

	public static void main(String[] args) {
		String[] msgs2 = { "abdcabd", "abcdefcdegef", "abcdefabcegef", "abcabcababc"};
		
		int count = countCodeAbc("abcabcababc");
		
		for(int i=0; i<msgs2.length; i++) {
			String msg = msgs2[i];
			String output = String.format("countCodeAbc(\"%s\")=%d", msg, countCodeAbc(msg));
			System.out.println(output);
		}
	}
	
	private static int countCodeAbc(String msg) {
		return countCodeAbc(msg, 0);
	}
	
	private static int countCodeAbc(String msg, int loc) {
		
		if(loc >= msg.length()-2) {  // base case
			return 0;
		}
		else {
			
			if(msg.substring(loc,loc+3).equals("abc")) {
				// If match, jump ahead 3
				return 1 + countCodeAbc(msg,loc+3);
			}
			else {
				// If no match, jump ahead 1, 0 not needed of course
				return 0 + countCodeAbc(msg,loc+1);
			}
		}
	}

}



