package examples_helper_store_intermediate;

public class Factorial {
	public static void main(String[] args) {
		for(int n=-1; n<11; n++) {
			long result = factorial(n);
			String msg = String.format("%9sfactorial(%d)=%d\n", " ", n, result);
			result = iterativeFactorial(n);
			msg += String.format("iterativeFactorial(%d)=%d", n, result);
			System.out.println(msg);
		}
	}

public static long factorial(long n) {
	if(n>=0) {
		return factorial(n, 1);  // recursive step
	}
	return Long.MIN_VALUE;
}

public static long factorial(long n, int result ) {
	if(n<=1) {
		return result;
	}
	result *= n;
	return factorial(n-1, result);
}

	private static long iterativeFactorial( long n ) {
		long fact = 1;
		for(int i=2; i<=n; i++) {
			fact *= i;
		}
		return fact;
	}
}



