package examples_primitive_no_helper;

public class Fibonacci {
	public static void main(String[] args) {
		long begTime, endTime, fib;
		double totTime;
		String msg;
		
//		if("abc" > "abd")
//			System.out.println("hi");
		
 		for(int i=0; i<51; i++) {
 			begTime = System.currentTimeMillis();
 			fib = iterativeFibonacci(i);
 			endTime = System.currentTimeMillis();
 			totTime = (endTime-begTime)/1000.0;
 			msg = String.format("Iterative: n=%d, fib(n)=%,d, time(sec)=%.1f", i, fib, totTime);
 			System.out.println(msg);

 			begTime = System.currentTimeMillis();
 			fib = fibonacci(i);
 			endTime = System.currentTimeMillis();
 			totTime = (endTime-begTime)/1000.0;
 			msg = String.format("Recursive: n=%d, fib(n)=%,d, time(sec)=%.1f", i, fib, totTime);
 			System.out.println(msg);
 		}
	}

	private static long fibonacci( long n ) {
		if( n == 0 )
			return 0;
		else if ( n == 1 )
			return 1;
		else
			return fibonacci(n-1) + fibonacci(n-2);
	}

	private static long iterativeFibonacci( long n ) {
		long f_n = 0;

		if( n == 0 )
			return 0;
		else if ( n == 1 )
			return 1;
		else {
			long f_n_minus_2 = 0;
			long f_n_minus_1 = 1;

			for( long i=2; i<n; i++ ) {
				f_n = (f_n_minus_1+f_n_minus_2);
				f_n_minus_2 = f_n_minus_1;
				f_n_minus_1 = f_n;
			}
			f_n = f_n_minus_1 + f_n_minus_2;
		}
		return f_n;
	}

}



