package examples_void_no_helper;

public class PrintStringInReverse
{
	public static void main(String[] args) {
		String val = "abcdefgh";
		printReverseString(val);
		System.out.println();
		printReverseString2(val);
	}
	
	public static void printReverseString(String s) {
		if(s.length()<=1) {  // base case
			System.out.print(s);
		}
		// recursive step
		else {
			// Print last character
			System.out.print(s.charAt(s.length()-1));
			// Remove last character before recursing
			printReverseString(s.substring(0,s.length()-1));
		}
	}
	
	// or
	
	private static void printReverseString2(String s) {
		if(s.length()>0) {
			System.out.print(s.charAt(s.length()-1));
			printReverseString2(s.substring(0,s.length()-1));
		}
		// implicit base case, simply returns automatically
		// when length is 0.
	}

}



