package exercises_helper_primitive;

public class CountCode {

	public static void main(String[] args) {
//		String[] msgs = { "abcdefcdegef", "abcdefcdegef", "abcdefcdegef","abbbbbfcdebbb", "aaaabb"};
//		String[] codes = { "cde", "bcd", "abd", "bbb", "bbb" };

		String[] msgs = { "beeeef", "beeeeef", "abcdefcd", "bcbc", "abcdbcbcabc", "sslsslcabssslcdresdessl" };
		String[] codes = { "ee", "ee", "cde", "bc", "bc", "sslc"};

		for(int i=0; i<msgs.length; i++) {
			String msg = msgs[i];
			String code = codes[i];
			String output = String.format("countCode(\"%s\",\"%s\")=%d", msg, code, countCode(msg,code));
			System.out.println(output);
		}
	}
	
	public static int countCode(String msg, String code) {
		return countCode(msg, code, 0);
	}
	
	private static int countCode(String msg, String code, int pos) {
		if(pos >= msg.length()-code.length()+1) {
			return 0;
		}
		else {
			if(msg.substring(pos,pos+code.length()).equals(code))
				return 1 + countCode(msg,code,pos+code.length());
			else
				return countCode(msg,code,pos+1);
		}
	}

}



