package exercises_helper_store_intermediate;

public class Power {
	public static void main(String[] args) {
		double x = 2;
		for(int n=0; n<11; n++) {
			double result = power(x,n);
			String msg = String.format("%1spower(%.2f, %d)=%.2f", " ", x, n, result);
			System.out.println(msg);
		}
	}
	
	public static double power(double x, int n) {
		if(n==0) {  // base case (stopping rule)
			return 1;
		}
		return x * power(x,n-1);  // recursive step
	}

	public static double power(double x, int n, double result) {
		if(n==0) {  // base case (stopping rule)
			return result;
		}
		result *= x;
		return power(x, n-1, result);  // recursive step
	}
}



