package exercises_helper_store_intermediate;
import java.util.ArrayList;
import java.util.Arrays;

public class ShortStrings {
	public static void main(String[] args) {
		ArrayList<String> vals = new ArrayList<>(Arrays.asList("abc", "ab", "ddefg", "zz", "kade"));
		String msg = String.format("shortStrings(%s,%d)=%s", vals, 4, shortStrings(vals,4));
		System.out.println(msg);		
	}
	
	private static ArrayList<String> shortStrings(ArrayList<String> strs, int len) {
		ArrayList<String> result = new ArrayList<>();
		return shortStrings(strs, len, 0, result);
	}
	
	private static ArrayList<String> shortStrings(ArrayList<String> strs, int len, int loc, ArrayList<String> result) {
		if(loc==strs.size()) {
			return result;
		}
		if(strs.get(loc).length()<len) {
			result.add(strs.get(loc));
		}
		return shortStrings(strs, len, loc+1, result);
	}
}



