package exercises_primitive_no_helper;

import java.util.Arrays;

public class ChangePi {

	public static void main(String[] args) {
		System.out.println("\nchangePi:");
		String[] stringsPi = {"xpix", "pipi", "pip", "abcpi", "abcpidefpighpipipi", ""};
		for( String s : stringsPi ) {
			String msg = String.format("changePi(\"%s\")=\"%s\"", s, changePi(s));
			System.out.println(msg);		
		}
	}
	
	public static String changePi(String str) {
		// Base cases:
		// If len < 2 then nothing left to change
		if( str.length() < 2)
			return str;
		if( str.substring(0,2).equals("pi")) {
			// Return is "3.14" + changePi on everything to the 
			// right of "pi"
			return "3.14" + changePi(str.substring(2));
		}
		else {
			// Return is 1st character + changePi on everything to the
			// right of 1st character
			return str.substring(0,1) + changePi(str.substring(1));
		}
	}
}
