package exercises_primitive_no_helper;

public class IsAllCharacters {
	public static void main(String[] args) {
		String[] vals = {"a", "1", "abC", "a bz", "ABCDEFghiz", "4aAb3"};
		String msg;
		for(String val : vals) {
			msg = String.format("isAllCharacters1(\"%s\")=%b", val, isAllCharacters1(val));
	 		System.out.println(msg);
			msg = String.format("isAllCharacters2(\"%s\")=%b", val, isAllCharacters2(val));
	 		System.out.println(msg);
			msg = String.format("isAllCharacters3(\"%s\")=%b", val, isAllCharacters3(val));
	 		System.out.println(msg);
		}
	}

	// best version
	private static boolean isAllCharacters1(String code) {
		if(code.length()==0) { 	// Base case
			return true;
		}
		if(Character.isLetter(code.charAt(0))) {
			return isAllCharacters1(code.substring(1,code.length()));
		}
		else {  // Another base case 
			return false;
		}
	}

	// version 2
	private static boolean isAllCharacters2(String code) {
		// Base cases
		if(code.length()==0) {
			return false;
		}
		else if( code.length() == 1 ) {
			if(Character.isLetter(code.charAt(0))) {
				return true;
			}
			else {
				return false;
			}
		}
		else {
			// Recurive step
			if(Character.isLetter(code.charAt(0))) {
				return isAllCharacters2(code.substring(1,code.length()));
			}
			// Another base case
			else {
				return false;
			}
		}
	}

	// version 2, a bit fancier...
	private static boolean isAllCharacters3(String code) {
		// Base cases
		if(code.length()==0) {
			return false;
		}
		else if( code.length() == 1 ) {
			if(Character.isLetter(code.charAt(0))) {
				return true;
			}
			else {
				return false;
			}
		}
		else {
			// Recurive step
			return isAllCharacters3( code.substring(0,1) ) && isAllCharacters3( code.substring(1,code.length() ) );
		}
	}
}
