package exercises_primitive_no_helper;

/*
 *  m(n) = 1/3 + 2/5 + 3/7 + ... + n/(2n+1)
 */

public class SumSeries2 {

	public static void main(String[] args) {
		for(int n=0; n<10; n++) {
			System.out.println( "n=" + n + ",  m(n)=" + m(n));
			System.out.println( "n=" + n + ", m2(n)=" + m2(n));
		}
	}

	// Better
	private static double m(int n) {
		if(n==1) {
			return 1/3.0;
		}
		if(n<=0) {
			return 0;
		}
		return n/(2.0*n+1) + m(n-1);
	}
	
	// or 
	private static double m2(int n) {
		if(n<=0) return 0;
		return n/(2.0*n+1) + m(n-1);
	}
}



