package exercises_primitive_no_helper;

/*
 *  m(n) = 1/2 + 2/3 + 3/4 + ... + n/(n+1)
 */
public class SumSeries3 {

	public static void main(String[] args) {
		for(int n=0; n<10; n++) {
			System.out.println( "n=" + n + ",  m(n)=" + m(n));
			System.out.println( "n=" + n + ", m2(n)=" + m2(n));
		}
	}
	
	private static double m(int n) {
		if(n==1) return 1/2.0;
		if(n<=0) return 0;
		return n/(n+1.0) + m(n-1);
	}
	
	// or
	private static double m2(int n) {
		if(n<=0) return 0;
		return n/(n+1.0) + m2(n-1);
	}
}



