package example_select_sort_person;

public class Person implements Comparable<Person> {

	private String name;
	private int ssn;

	public Person( String name, int ssn ) {
		this.name = name;
		this.ssn = ssn;
	}

	public String getName() {
		return name;
	}

	public int getSsn() {
		return ssn;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String toString() {
		String msg = String.format("Name: %s, ssn: %d", name, ssn);
		return msg;
	}

	@Override
	public int compareTo(Person otherPerson) {
		return this.ssn-otherPerson.ssn;
	}

}
