package examples_helper_primitive;

public class IsPalindrone {
	public static void main(String[] args) {
		String[] strs = {"dened", "daned", "anna", "anba", "123456654321", "123421"};
		for(String s : strs) {
			System.out.println("isPalindrome(" + s + ")=" + isPalindrome(s));
			System.out.println("isPalindrome2(" + s + ")=" + isPalindrome2(s));
			System.out.println("isPalindrome3(" + s + ")=" + isPalindrome3(s) + ", incorrect");
		}
	}
	
	public static boolean isPalindrome(String s) {
		if(s.length() <= 1 )  // base case
			return true;
		int first = 0;
		int last = s.length()-1;
		return isPalindrome(s,first,last);
	}
	
	private static boolean isPalindrome(String s, int first, int last) {
		if(first>=last) {  // base case
			return true;
		}
		else if(s.charAt(first) != s.charAt(last)) {  // base case
			return false;
		}
		else {
			return isPalindrome(s,first+1,last-1);
		}
	}

	public static boolean isPalindrome2(String s) {
		if(s.length() <= 1 )  // base case
			return true;
		return isPalindrome2(s,0,s.length()-1);
	}
	
	private static boolean isPalindrome2(String s, int first, int last) {
		if(first==last) {  // base case for odd length string
			return true;
		}
		else if(s.charAt(first) != s.charAt(last)) {
			return false;
		}
		else {
			if(first==last-1) {  // base case for even length string
				return true;
			}
			else {
				return isPalindrome2(s,first+1,last-1);
			}
		}
	}

	public static boolean isPalindrome3(String s) {
		if(s.length() <= 1 )  // base case
			return true;
		return isPalindrome3(s,0,s.length()-1);
	}
	
	// Incorrect
	private static boolean isPalindrome3(String s, int first, int last) {
		if(first==last || first==last-1)  // base case
			return true;
		else if(s.charAt(first) != s.charAt(last))  // base case
			return false;
		else
			return isPalindrome3(s,first+1,last-1);
	}

}
