package examples_helper_primitive;
import java.util.Arrays;
public class SumArray {
	public static void main(String[] args) {
		
		int[] vals = {2,3,91,4};
		int sum = sumArray(vals,0);
		System.out.println("vals=" + Arrays.toString(vals) + ", sum=" + sumArray( vals ));
		try {
			System.out.println("vals=" + Arrays.toString(vals) + ", sum=" + sumArrayIncorrect( vals ));
		}
		catch(Throwable t) {
			System.out.println(t);
		}
	}
	
	private static int sumArray(int[] vals) {
		return sumArray(vals,0);
	}
	
	private static int sumArray(int[] vals, int loc) {
		if(loc>=vals.length) {  // base case
			return 0; 
		}
		// recursive step
		return vals[loc] + sumArray(vals, loc+1);
	}
	
	private static int sumArrayIncorrect(int[] vals) {
		int i=0;

		if(i<vals.length) {
			return vals[i++] + sumArrayIncorrect(vals);
		}
		else {
			return 0; 
		}
	}
}



