package examples_primitive_no_helper;

public class Factorial
{

	public static void main(String[] args) {
		try {
//			System.out.println( factorial2(100) );
			System.out.println( factorial(10) );
		}
		catch(StackOverflowError e) {
			System.out.println(e);
		}

//		System.out.println( iterativeFactorial(5) );
	}
	
	public static long factorial( long n ) {
		if(n==1 || n==0) {  // base case (stopping rule)
			return 1;
		}
		return n * factorial(n-1);  // recursive step
	}
	
	// No stopping rule. Designed to illustrate failure.
	public static long factorial2( long n ) {
		System.out.println(n);
		return n * factorial2(n-1);
	}

	private static long iterativeFactorial( long n ) {
		long fact = 1;
		for(int i=2; i<=n; i++) {
			fact *= i;
		}
		return fact;
	}
}



