package examples_primitive_no_helper;

public class SumInts {
	public static void main(String[] args) {
		int max = 16;

		System.out.println("recur, iter, diff");
		for(int i=1; i<max; i++) {
			long recur = sumInts(i);
			long iterative = sumIntsIterative(i);
			long diff = recur - iterative;
			String msg = String.format("n=%d - %,d, %,d, %d", i, recur, iterative, diff);
	 		System.out.println(msg);
		}

	}
	
	private static long sumInts(int n) {
		if(n==1) {  // base case
			return 1;
		}
		return n + sumInts(n-1);  // recursive step
	}
	
	private static long sumIntsIterative(long n) {
		long sum = 1;
		for(long i=2; i<=n; i++ ) {
			sum += i;
		}
		return sum;
	}

}